function u=MinimumWay(MaxN,A,s,e)
%Obyavleniye:
%   function u=MinimumWay(A)
%Vhodniye parametri:
%MaxN - kolichestvo uzlov v graphe.
%A-massiv reber grapha.
%s - nachalniy uzel
%e - konechniy uzel
%
%Primer vhodnih parametrov:
%Mnoshestvo vershin: {1,2,3,4,5}
%Mnoshestvo reber: {(1,2),(1,3),(2,3),(2,5),(3,4),(3,5),(4,2),(4,5))}
% S cenami:           21    32  34      34    34    45    34    34
%V etom sluchae chislo MaxN dolshno ravnyatsya 5;
%V etom sluchae vhodnoy massiv A dolshen bit takim:
%A=[1   1   2   2   3   3   4   4
%   2   3   3   5   4   5   2   5
%  21   32  34  34  34  45  34  34]
%   ^   ^   ^
%   |   |   |
%(1,2)(1,3)(1,4)...
%
%Funkciya vozvrashaet  spisok metok, poluchennih algoritmom Deykstri
%u(:,1) - pervaya metka
%u(:,2) - vtoraya metka
%...
%Ispolzuyte funkciyu MWWriteDecision dlya togo, chtobi vivesti reshe-
%niye na ekran.
%
%
%Posetite http://urvanov.ru


%Vichislim razmer massiva A
[n,SizeA]=size(A);
%Vashna tolko peremennaya SizeA. kolichestvo strok n vseg-
%da ravno 3.

%Massiv u.
for n=1:MaxN u(1,n)=NaN; u(2,n)=NaN; end;
Post=zeros(MaxN,1);

%ETAP 0.
%Ishodnomu uzlu prisvaivaetsya postoyannaya metka [0,-]
CONST=2;
TEMP=1;
u(1,s)=0;

Post(s)=CONST;
LastPost=s;

%polagaem i=1;
i=1;

yes=1;
while yes
%ETAP 1.
%a)Vichislyaem vremenniye metki [ui+dij,i] dlya vseh uzlov j,
%kotoriye moshno dostich neposredstvenno iz uzla i i kotorie
%ne imeyut postoyannih metok.
for n=1:SizeA
    if (  (A(1,n)==LastPost)&&(Post(A(2,n))~=CONST)  )
        Newu=u(1,LastPost)+A(3,n);
        
        %Esli uzel A(2,n) ushe imeet metku, poluchennuyu ot
        %drugogo uzla, i, esli Novaya metka menshe staroy,to
        %to zamenim staruyu metku na novuyu.
        if not (u(1,A(2,n))<=Newu)
            u(1,A(2,n))=Newu;
            u(2,A(2,n))=LastPost;
            Post(A(2,n))=TEMP;
        end;
    end;
end;

%b)Esli vse uzli imeyut postoyanniye metki, to process vichi-
%sleniy zakanchivaetsya. V protivnom sluchae vibiraetsya metka
%[umax,s] s naimenshim znacheniyem rasstoyaniya u sredi xseh vre-
%mennih metok (esli takih metok neskolko, to vibor proizvolniy).
%Polagaem i=r i povtoryaem etap i.
max=1;
for n=1:MaxN
    if (  (Post(n)==TEMP)&& ((u(1,n)<u(1,max))||(max==1)) )
        max=n;       
    end;
end;

if (max~=1)
    %Polagaem i=max;
    Post(max)=CONST;
    i=max;
    LastPost=max;
else
    %Esli vse uxli s postoyannimi koefficientami, to zavershaem
    %cikl.
    yes=0;
end;

end;
u;

% Post
